var Print = require('./print');

var common = require('../common');
var temp = require('temp');
var fs = require('fs');
var es = require('event-stream');

Print.prototype.visualizePrint = function(callback) {
  var _this = this;

  var cmdList = ["G0", "G1", "G92", "G91", "G90", "TOOLCHANGE"];
  var VizProcess = require('../procedures/visualizer-gcode-process');

  var readableStream = fs.createReadStream(_this.tempFile)
    .setEncoding('utf-8')
    .pipe(es.split())
    .pipe(es.mapSync(function(line){

      // Pause reading stream for processing
      readableStream.pause();

      (function(){

        // Processes each line, and streams to new gcode line
        var args = common.parseLine(line);
        if ( args && args.cmd && ~cmdList.indexOf(args.cmd) ) {
          VizProcess[ args.cmd ](_this.vizModel, args);
        }

        // Resume reading stream
        readableStream.resume();

      })();
    })
    .on('error', function(){
      console.log('Error while reading file.');
    })
    .on('close', function(){
      typeof callback === 'function' && callback();
    })
  );
};