module.exports = Print = (function() {

  Print.create = function() {
    return new Print();
  };

  function Print() {
    this.init();
    require('./print-parse');
    require('./print-tower');
    require('./print-visualize');
    this.loadPrinterDefaults();
  };

  Print.prototype.init = function() {
    this.Ecurrent = 0;
    this.Eprev = 0;
    this.Etotal = 0;
    this.Ereset = 0;
    this.oldTool = 0;
    this.oldDiff = 0;
    this.relPosition = false;
    this.firstSwitch = true;
    this.firstTool = true;
    this.relativeExtrude = true;
    this.inputFile = "";
    this.tempFile = "";
    this.outputFile = "";

    this.slicerName = "";

    this.printBedDimensions = {
      x: 0,
      y: 0,
      z: 0,
      originMiddle: true,
    };

    this.heightTracking = {
      currentZ: 0
    };

    this.filamentLengthArray = [];
    this.writeArray = [];
    this.writeTowerArray = [];
    this.writeHeightArray = [];
    this.writePingArray = [];
    this.printLayers = [];

    this.towers = false;
    this.towerLength = 0;
    this.towerVolume = 0;
    this.towerFastRate = 0;
    this.towerSlowRate = 0;
    this.pieceOffset = 0;

    this.headerArray = {
      drivesUsed: [0, 0, 0, 0],
      pulsesPerMM: 0,
      loadingOffset: 0,
      stepsPerCount: 0,
      spliceDist: 0,
      cutterOptoDist: 0,
      spliceCount: 0,
      pingCount: 0,
    };

    this.vizModel = {
      Ecurrent: 0,
      Eprev: 0,
      Etotal: 0,
      Ereset: 0,
      oldTool: 0,
      oldDiff: 0,
      relPosition: false,
      firstSwitch: true,
      relativeExtrude: true,
      currentLayer: { x: 0, y: 0, z: 0, e: 0 },
      lastLayer: { x: 0, y: 0, z: 0, e: 0 },
      geometryArr: [],
    };

    this.driveColour = [ "#4325C6", "#FF7C13", "#0EB7B1", "#FFD213" ];
    this.currentLayer = { x: 0, y: 0, z: 0, e: 0 };
    this.lastLayer = { x: 0, y: 0, z: 0, e: 0 };
    this.boundingBox = { x: 1000, y: 0, z: 0, e: 0 };
    this.layerColourCount = [];
    this.maxColourChange = 0;
  };

  return Print;

})();