var THREE = require('three');
var ieee754 = require('ieee754');

module.exports = {
	"G92": function (model, args) {
    if (args && args.e != undefined) {
      model.Ereset = args.e;

      //if (model.Ecurrent < 0) {
      //  model.Etotal += (model.Ecurrent - model.Eprev);
      //} else {
      //  model.Etotal -= model.Ereset;
      //}

      model.Ecurrent = model.Ereset;
      model.Eprev = 0;
    }

    return
  },

  "G91": function(model, args) {
    model.Eprev = 0;
    model.relPosition = true;
    return
  },

  "G90": function(model, args) {
    model.Eprev = 0;
    model.relPosition = false;
    return
  },

  "G1": function(model, args) {
    if (args && args.e != undefined) {
      model.Ecurrent = args.e;
      model.currentLayer.e = args.e;

      if (model.relPosition == false) {
        if (model.Ecurrent > model.Eprev) {
          model.Etotal += (model.Ecurrent - model.Eprev);
          model.Eprev = model.Ecurrent;
        } else if (model.Ecurrent < model.Eprev && model.Ecurrent <= 0) {
          //model.Etotal += (model.Ecurrent - model.Eprev);
          //model.Eprev = model.Ecurrent;
        } else {
          null;
        }
      } else {
        if (model.Ecurrent > model.Eprev) {
          model.Etotal += model.Ecurrent;
        }
      }
    }

    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    model.lastLayer = args;
    return
  },

  "G0": function(model, args) {
    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    return
  },

  "TOOLCHANGE": function(model, args) {
    if ( ~model.printLayers.indexOf(model.currentLayer.z) && model.firstSwitch == true ) {
      model.firstSwitch = false;
      model.oldTool = args.t;
    } else {
      if ( ~model.printLayers.indexOf(model.currentLayer.z) ) {
        var spliceLength = model.Etotal;

        // Adding length into filament length array
        model.filamentLengthArray.push(model.Etotal-model.oldDiff);

        // Setting filamentString and pushing into array for writing SEEM file
        model.writeArray.push( [model.oldTool, spliceLength] );

        model.headerArray.spliceCount += 1;

        // Pushing colour to colorArray for later counting of unique colours used
        model.headerArray.drivesUsed[model.oldTool] = 1;

        // Setting variables for next tool switch, and resetting switchBool to false
        model.oldTool = args.t;
        model.oldDiff = model.Etotal;
      }
    }

    return
  },

  "null": function(model, args) {
    return
  }
}