var THREE = require('three');
var ieee754 = require('ieee754');

module.exports = {
  "G92": function (model, args) {
    return
  },

  "G91": function(model, args) {
    return
  },

  "G90": function(model, args) {
    return
  },

  "G1": function(model, args) {
    if (args && args.e != undefined) {
      model.Ecurrent = parseFloat(args.e);
      model.Etotal += model.Ecurrent;
    }

    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    model.lastLayer = args;
    return
  },

  "G0": function(model, args) {
    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    return
  },

  "TOOLCHANGE": function(model, args) {
    if ( ~model.printLayers.indexOf(model.currentLayer.z) && model.firstSwitch == true ) {
      model.firstSwitch = false;
      model.oldTool = args.t;
    } else {
      if ( ~model.printLayers.indexOf(model.currentLayer.z) ) {
        var spliceLength = model.Etotal;

        // Adding length into filament length array
        model.filamentLengthArray.push(model.Etotal-model.oldDiff);

        // Setting filamentString and pushing into array for writing SEEM file
        model.writeArray.push( [model.oldTool, spliceLength] );
        model.headerArray.spliceCount += 1;

        // Pushing colour to colorArray for later counting of unique colours used
        model.headerArray.drivesUsed[model.oldTool] = 1;

        // Setting variables for next tool switch, and resetting switchBool to false
        model.oldTool = args.t;
        model.oldDiff = model.Etotal;
      }
    }

    return
  },

  "null": function(model, args) {
    return
  }
}